\SCROLLER.XPL	26-JUL-2001	Lenny Boreal
\Yer basic message scroller (with background pattern) in 320x200x256 graphics

include	\cxpl\codesi;	\run-time library routines (intrinsics)

seg char Image(1);	\array for setting up copy of screen image
int	FCtr,		\frame counter
	FontHeight,	\char height in pixels = number of bytes per char
	FontOff,	\address of BIOS font table (offset and segment)
	FontSeg,
	MsgX,		\horizontal coordinate of beginning of message (pixels)
	Reg;		\pointer to array holding processor's registers
def	MsgLen=72;	\number of characters in scroll message (see Main)



proc	FillBkgnd;	\Fill background with moving geometric pattern
int	X, Y, Z;	\screen coordinates (pixels), index for Image array
begin
Z:= 0;
for Y:= 0, 200-1 do			
    for X:= 0, 320-1 do
	begin
	Image(0, Z):= X+FCtr ! Y+FCtr | FCtr;	\jumpin' Sierpinskis!
	Z:= Z + 1;
	end;
end;	\FillBkgnd



proc	DrawTile(X0, Y0, S, C);	\Draw a square tile
int	X0, Y0, S, C;		\location (pixels), length of side, color
int	X, Y, J;
begin
if X0 >= 320-S then return;	\clip to screen (X0 is always positive)

Y:= Y0 * 320;
for J:= 0, S-1 do
	begin
	for X:= X0, X0+S-1 do Image(0, Y+X):= C;
	Y:= Y + 320;
	end;
end;	\DrawTile



func	DispCh(X0, Y0, Ch);	\Display a character
int	X0, Y0, Ch;		\upper-left coordinates, character
int	X, Y, S, I, J, Byte;	\coordinates, size, indicies, font byte
begin
for J:= 0, FontHeight-1 do
	begin			\get byte from BIOS's font table
	Byte:= Peek(FontSeg,  FontOff + Ch*FontHeight + J);
	X:= X0;
	for I:= 0, 7 do		\for each bit in the Byte...
		begin
		if X < 0 then			\reflect small character
			begin
			S:= 1;			\size = small tiles
			Y:= J + Y0 + 75;	\start at base line
			end
		else	begin
			S:= 12;			\size = large tiles
			Y:= S*J + Y0;		\start at top
			end;
		if Byte & $80 then
			begin	\abs creates mirror image of char
			DrawTile(abs(X), Y, S, $00\black\);	\outline
			DrawTile(abs(X+1), Y+1, S-2, $0F\white\);
			end;
		Byte:= Byte << 1;
		X:= X + S;	\move to next tile position
		end;
	end;
return X;			\return horizontal location for next char
end;	\DispCh



proc	DispMsg(X, Y, Msg);	\Display a message
int	X, Y;			\coordinates of start of message
char	Msg;			\pointer to message
int	I;
for I:= 0, MsgLen-1 do
	X:= DispCh(X,  Y,  Msg(I));



begin	\Main
Image(0):= Malloc(4000);		\allocate a 64000-byte staging buffer

SetVid($13);				\set 320x200x256 graphic mode
Reg:= Getreg;
Reg(0):= $1130;				\get font height and table location
Reg(1):= $0100;
Softint($10);
FontHeight:= Reg(2);
FontOff:= Reg(6);
FontSeg:= Reg(11);

FCtr:= 36;				\initialize counter for moving backgnd
loop	begin
	MsgX:= 0;			\initialize horizontal location of msg
	repeat	FillBkgnd;
		DispMsg(MsgX, 60,
  "         ...yer basic scroller...with jumpin' graphics...all in XPL0!  ^B ");
 	Blit(Image(0), 0, $A000, 0, 64*1000);	\copy image to screen
		if Chkkey then quit;	\any keystroke terminates program
		Sound(0, 1, 1);		\speed limit = 18.2 frames per second
		MsgX:= MsgX - 1;	\shift message to the left
		FCtr:= FCtr - 1;	\move background
	until MsgX < -(MsgLen*8 + 320);	\small message is shifted off screen
	end;

Openi(0);				\eat keystroke
SetVid($03);				\restore normal text display
end;	\Main
